#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_texture;
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform float x0;
uniform float x1;
uniform float y0;
uniform float y1;

uniform vec4 u_amountColor;

void main(void) {
    float x = v_texCoord.x;
    float y = v_texCoord.y;
    
    float tx0 = 101.0 / 384.0;
    float tx1 = 283.0 / 384.0;
    float ty0 = 75.0 / 442.0;
    float ty1 = 367.0 / 442.0;
    
    float wRate = (x1 - x0) * 384.0 / 182.0;
    float hRate = (y1 - y0) * 442.0 / 292.0;

    if (x > tx0 && x < tx1 && y > ty0 && y < ty1) {
        float dx = x - tx0;
        float px = x0 + dx * wRate;
        float dy = y - ty0;
        float py = y0 + dy * hRate;
        if (px >= 0.0 && px <= 1.0 && py >= 0.0 && py <= 1.0) {
            vec4 col = v_fragmentColor * texture2D(u_texture, fract(vec2(px, py)));
            gl_FragColor = vec4(col.r, col.g, col.b, col.a);
        } else {
            gl_FragColor = vec4(0, 0, 0, 0);
        }
    } else {
        gl_FragColor = vec4(0, 0, 0, 0);
    }

    if (gl_FragColor.a > 0.05) {
        gl_FragColor += u_amountColor * gl_FragColor.a;
    }
}
